## simple-netaid-gtk 1.0.8

=== Makefile ===

UI_DIR   := ui

DESTDIR ?=
PREFIX ?= /usr/local
BINDIR ?= $(DESTDIR)$(PREFIX)/bin

GTK_VERSION    ?= 3

PROG := $(patsubst %, %$(shell echo $(GTK_VERSION)), simple-netaid-gtk)

MAKEFLAGS += --no-builtin-rules

# Ajuste de la ruta del binario generado
PROG_PATH := $(UI_DIR)/$(PROG)

# Aseguramos que 'all' invoque al sub-makefile
all:
	@$(MAKE) -r -C $(UI_DIR) $(PROG)

# Regla de instalación corregida
install:
	# Crear directorios necesarios
	mkdir -p $(BINDIR)
	mkdir -p $(DESTDIR)/etc/simple-netaid
	mkdir -p $(DESTDIR)$(PREFIX)/share/pixmaps
	mkdir -p $(DESTDIR)$(PREFIX)/share/simple-netaid
	mkdir -p $(DESTDIR)$(PREFIX)/share/applications

	# Instalar binario (buscándolo en la subcarpeta UI)
	cp -v $(PROG_PATH) $(BINDIR)/$(PROG)

	# Instalar configuración
	cp -v config/gtk.ini $(DESTDIR)/etc/simple-netaid/gtk.ini

	# Instalar Desktop file
	cp -v simple-netaid-gtk.desktop $(DESTDIR)$(PREFIX)/share/applications/

	# Instalar Iconos (Usando un bucle o lista para evitar repetición)
	cp -v images/SimpleNetaid.png $(DESTDIR)$(PREFIX)/share/pixmaps/
	cp -v images/*.png $(DESTDIR)$(PREFIX)/share/simple-netaid/

uninstall:
	rm -f $(BINDIR)/$(PROG)
	rm -rf $(DESTDIR)/etc/simple-netaid
	rm -rf $(DESTDIR)$(PREFIX)/share/simple-netaid
	rm -f $(DESTDIR)$(PREFIX)/share/pixmaps/SimpleNetaid.png
	rm -f $(DESTDIR)$(PREFIX)/share/applications/simple-netaid-gtk.desktop

clean:
	$(MAKE) -r -C $(UI_DIR) clean

cleanall:
	$(MAKE) -r -C $(UI_DIR) cleanall
	rm -vf $(wildcard *~)

.PHONY: all install clean cleanall uninstall

=== ui/Makefile ===
PREFIX    ?= /usr
GTK_VERSION ?= 3

# Iconos
APP_ICON           := ../images/simple_netaid.ico
BRAND_ICON         := ../images/SimpleNetaid.png
CONNECTED_ICON     := ../images/network-transmit-receive.ico
DISCONNECTED_ICON  := ../images/network-wired-disconnected.ico
VIEW_REFRESH_ICON  := ../images/view-refresh.png
WIRED_ICON         := ../images/wired.png

# Objetos
OBJECTS := userinfo.o netaid-config.o netaid-saved-wifis.o netaid-password-dialog.o \
	netaid-pixbuf.o netaid-active-wifis.o netaid-menu-bar.o netaid-toolbar.o netaid-notebook.o \
	netaid-status-icon.o netaid-window.o main.o

# Configuración de Flags según GTK_VERSION
ifeq ($(GTK_VERSION),2)
    VTE_PKG := vte
    GTK_PKG := gtk+-2.0
else
    VTE_PKG := vte-2.91
    GTK_PKG := gtk+-3.0
endif

# PKG_CONFIG acumulado
PKGS := $(VTE_PKG) glib-2.0 $(GTK_PKG) libubus libubox json-c gdk-x11-3.0 x11

CFLAGS  += `pkg-config --cflags $(PKGS)` \
			-Wno-deprecated-declarations \
			-D_GNU_SOURCE \
			-I..

LDLIBS  += `pkg-config --libs $(PKGS)` \
			-lnetaid -linih \
			 -lubox -lblobmsg_json -ljson-c

PROG := simple-netaid-gtk$(GTK_VERSION)

all: $(PROG)

# Generación de recursos (Pixbufs)
# Se generan antes de compilar netaid-pixbuf.o
netaid-pixbuf.o: netaid-pixbuf.c app_16x16 brand_16x16 connected_16x16 disconnected_16x16 view_refresh_16x16 wired_16x16  
	$(CC) $(CFLAGS) -c $< -o $@

# Regla específica para los csource (puedes añadir los demás iconos aquí)
app_16x16: $(APP_ICON)
	gdk-pixbuf-csource --raw --name=app_16x16 $(APP_ICON) > $@

brand_16x16: $(BRAND_ICON)
	gdk-pixbuf-csource --raw --name=brand_16x16 $(BRAND_ICON) > $@

connected_16x16: $(CONNECTED_ICON)
	gdk-pixbuf-csource --raw --name=connected_16x16 $(CONNECTED_ICON) > $@

disconnected_16x16: $(DISCONNECTED_ICON)
	gdk-pixbuf-csource --raw --name=disconnected_16x16 $(DISCONNECTED_ICON) > $@

view_refresh_16x16: $(VIEW_REFRESH_ICON)
	gdk-pixbuf-csource --raw --name=view_refresh_16x16 $(VIEW_REFRESH_ICON) > $@

wired_16x16: $(WIRED_ICON)
	gdk-pixbuf-csource --raw --name=wired_16x16 $(WIRED_ICON) > $@

# ... repetir para los demás iconos si es necesario ...

# Regla genérica para objetos
%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

$(PROG): $(OBJECTS)
	$(CC) -o $@ $^ $(LDFLAGS) $(LDLIBS)

.PHONY: clean cleanall

clean:
	rm -f *.o *~ app_16x16 brand_16x16 connected_16x16 disconnected_16x16 view_refresh_16x16 wired_16x16

cleanall: clean
	rm -f simple-netaid-gtk2 simple-netaid-gtk3

=== debian/changelog ===
simple-netaid-gtk (1.0.8-1+6genuen1) unstable; urgency=medium

  * Rewrite from scratch in gtk and C
  * New upstream version 1.0.8

 -- Aitor <aitor@genuen.org>  Mon, 16 Feb 2026 20:30:48 +0100

simple-netaid-gtk (1.0.7-1+5gnuinos1) unstable; urgency=medium

  * Verify whether netaid group is not assigned to the current user 
    account. If not, show a warning dialog.
  * New upstream version 1.0.7

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 05 May 2024 19:39:42 +0200

simple-netaid-gtk (1.0.6-1+5gnuinos2) unstable; urgency=medium

  * Add isc-dhcp-client and udhcpc -the busybox version of dhcpcd5- as 
    alternative runtime dependencies to dhcpcd5

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 05 May 2024 13:23:49 +0200

simple-netaid-gtk (1.0.6-1+5gnuinos1) unstable; urgency=medium

  * Improve the password dialog 
  * Mask SIGUSR2 before ubus calls; otherwise, the gui freezes
  * Receive active wifis in json format
  * Depend on libjsoncpp-dev
  * New upstream version 1.0.6

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 04 May 2024 09:21:14 +0200

simple-netaid-gtk (1.0.5-1+5gnuinos1) unstable; urgency=medium

  * Initilize Glib before using Glib::RefPtr<Gio::File> in main.cpp 
  * New upstream version 1.0.5

 -- Aitor <aitor_czr@gnuinos.org>  Mon, 29 Apr 2024 21:32:39 +0200

simple-netaid-gtk (1.0.4-1+5gnuinos1) unstable; urgency=medium

  * Fix Gtk warnings 
  * New upstream version 1.0.4

 -- Aitor <aitor_czr@gnuinos.org>  Mon, 29 Apr 2024 02:34:12 +0200

simple-netaid-gtk (1.0.3-1+5gnuinos1) unstable; urgency=medium

  * Use scrolled windows as containers for the vte terminal emulators. 
    This fixes a bug in the Gtk2 version where the size of the terminals
    increased unexpectedly. 
  * New upstream version 1.0.3

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 21 Apr 2024 23:14:45 +0200

simple-netaid-gtk (1.0.2-1+5gnuinos1) unstable; urgency=medium

  * Wape up wireless interface whenever a usb wifi adapter is attached. 
    Nofifications about attachment events will come from netlink monitor.
  * New upstream version 1.0.2

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 21 Apr 2024 13:05:58 +0200

simple-netaid-gtk (1.0.1-1+5gnuinos1) unstable; urgency=medium

  * Build with both Gtk2 and Gtk3
  * New upstream version 1.0.1

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 20 Apr 2024 16:40:51 +0200

simple-netaid-gtk (1.0.0-1+5gnuinos1) unstable; urgency=medium

  * Initial release

 -- Aitor <aitor_czr@gnuinos.org>  Tue, 16 Apr 2024 23:55:55 +0200

=== debian/control ===
Source: simple-netaid-gtk
Section: net
Priority: optional
Maintainer: Aitor Cuadrado Zubizarreta <aitor@genuen.org>
Build-Depends: debhelper (>= 12),
  dpkg-dev (>= 1.16.1~),
  pkg-config (>= 0.29.2-1~),
  gettext,
  intltool,
  libnetaid-dev (>= 1.5.2-1~),
  libgtk-3-dev (>= 3.24.49~),
  libubus-dev (>= 19.07+3~),
  libjson-c-dev (>= 0.18+ds~),
  libvte-2.91-dev (>= 0.70.6-2~),
  libinih-dev (>= 55-1), 
Standards-Version: 4.5.1
Origin: Genuen
Homepage: https://genuen.org

Package: simple-netaid-gtk3
Section: net
Architecture: linux-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
  dhcpcd5,
  ifupdown2,
  wpasupplicant,
  libiw30,
  snetaid (>= 1.5.5-1~),
  ubus (>= 19.07+2~)
Conflicts: simple-netaid-vte3,
  simple-netaid-cdk,
  nl-monitor
Recommends: 
Description: Gtk3 interface for simple-netaid
 This package contains a graphical interface for simple-netaid developed 
 with the Gtk3 toolkit.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export GTK_VERSION=3

export DH_VERBOSE = 1
export PREFIX=/usr

APP := $(shell echo "simple-netaid-gtk$(GTK_VERSION)")

%:
	dh $@

override_dh_auto_install:
	install -m0755 -d debian/$(APP) 

override_dh_install:
	install -m0755 -d debian/$(APP)/etc/simple-netaid
	cp --reflink=auto -a config/gtk.ini debian/$(APP)/etc/simple-netaid/
	install -m0755 -d debian/$(APP)/usr/bin
	cp --reflink=auto -a ui/$(APP) debian/$(APP)/usr/bin/
	install -m0755 -d debian/$(APP)/usr/share/applications
	cp --reflink=auto -a simple-netaid-gtk.desktop debian/$(APP)/usr/share/applications/
	install -m0755 -d debian/$(APP)/usr/share/pixmaps
	cp --reflink=auto -a images/SimpleNetaid.png debian/$(APP)/usr/share/pixmaps/
	install -m0755 -d debian/$(APP)/usr/share/simple-netaid
	cp --reflink=auto -a ./images/SimpleNetaid.png ./images/connected.png ./images/disconnected.png \
		./images/view-refresh.png ./images/wired.png ./images/wireless.png \
		debian/$(APP)/usr/share/simple-netaid/
